local TSMPriceReply = select(2, ...)
local TSMPriceReply = LibStub("AceAddon-3.0"):NewAddon(TSMPriceReply,"TradeSkillMaster_PriceReply", "AceConsole-3.0")
local PROptions = TSMPriceReply:NewModule("PROptions", "AceEvent-3.0", "AceHook-3.0")
local TSMPRGUI = LibStub("AceGUI-3.0")
TSMPriceReply.version = GetAddOnMetadata("TradeSkillMaster_PriceReply", "Version")

------------------ VARIABLES -----------
local ReplyChannelSayDropDownBox = {["WHISPER"]="WHISPER",["SAY"]="SAY"}
local ReplyChannelGuildDropDownBox = {["WHISPER"]="WHISPER",["GUILD"]="GUILD"}
local PRAddonEnabled --- to stop abuse
local PRTrigger --- The Trigger holder
local PRAddonDelayCheck = 0
local LastRunDelayTime = 0
local PRLockOutTime -- trigger to stop abuse default 15
local PRChannel --- triggers for whispers or guild or say
local PRGuildChannel
local PRTriggerLength --- gets length of triggers
local PRCheckEnabled --- hold wether the checkbox is checked or not

---- Register Frames ---
local TSMPRframe = CreateFrame('FRAME')
TSMPRframe:SetScript("OnEvent", function(the, event, ...)
	TSMPREvents[event](...)
end)
TSMPRframe:RegisterEvent("CHAT_MSG_GUILD")
TSMPRframe:RegisterEvent("ADDON_LOADED")
TSMPRframe:RegisterEvent("CHAT_MSG_WHISPER")
TSMPRframe:RegisterEvent("CHAT_MSG_SAY")
TSMPREvents = {}
-------

----- ADDDON LOADED ---

function TSMPREvents.ADDON_LOADED()
	if not TradeSkillMaster_PriceReplyDB then
		TradeSkillMaster_PriceReplyDB = {}
	end
	if not TradeSkillMaster_PriceReplyDB.PRAddonEnabled then
		TradeSkillMaster_PriceReplyDB.PRAddonEnabled = true
	end
	if not TradeSkillMaster_PriceReplyDB.PRTrigger then
		TradeSkillMaster_PriceReplyDB.PRTrigger = "PR: "
	end
	if not TradeSkillMaster_PriceReplyDB.PRLockOutTime then
		TradeSkillMaster_PriceReplyDB.PRLockOutTime = 15
	end
	if not TradeSkillMaster_PriceReplyDB.PRChannel then
		TradeSkillMaster_PriceReplyDB.PRChannel = "WHISPER"
	end
	if not TradeSkillMaster_PriceReplyDB.PRGuildChannel then
		TradeSkillMaster_PriceReplyDB.PRGuildChannel = "WHISPER"
	end

	PRChannel = TradeSkillMaster_PriceReplyDB.PRChannel
	PRGuildChannel = TradeSkillMaster_PriceReplyDB.PRGuildChannel
	PRLockOutTime = TradeSkillMaster_PriceReplyDB.PRLockOutTime
	PRTrigger = TradeSkillMaster_PriceReplyDB.PRTrigger
	PRTriggerLength = string.len(PRTrigger)
	PRAddonEnabled = TradeSkillMaster_PriceReplyDB.PRAddonEnabled
	TSMPRframe:UnregisterEvent("ADDON_LOADED")
end


-- Initiate TSM Stuff so it recognizes it
function TSMPriceReply:OnEnable()
	TSMAPI:RegisterReleasedModule("TradeSkillMaster_PriceReply", TSMPriceReply.version, GetAddOnMetadata("TradeSkillMaster_PriceReply", "Author"), GetAddOnMetadata("TradeSkillMaster_PriceReply", "Notes"))
	TSMAPI:RegisterSlashCommand('pr', function(...) PROptions:Load(...) end, "Opens the Price Reply Options")
	TSMAPI:RegisterIcon("Price Reply","Interface\\Icons\\ACHIEVEMENT_GUILDPERK_QUICK AND DEAD",function(...) PROptions:Load(...) end,"TradeSkillMaster_PriceReply","module")
end


--------------- TSM BUILD PAGE-------------
function PROptions:Load(parent)
	local page = {
		{
		 type = "SimpleGroup",
		 layout = "list",
		 children = {
			{
				type = "InlineGroup",
				fullWidth = true,
				layout = "flow",
				title = "Price reply Options",
				children = {
					{
					type = "EditBox",
					value = TradeSkillMaster_PriceReplyDB.PRTrigger,
					label = "Trigger",
					fullWidth = false,
					disabled = false, -- OPTIONAL - false by default
					tooltip = "The triger used at the start of a sentence for asking the price", -- OPTIONAL
					callback = function(_,_,value) PRTrigger = tonumber(value);TradeSkillMaster_PriceReplyDB.PRTrigger = PRTrigger; end,
					},
					{
					type = "CheckBox",
					value = TradeSkillMaster_PriceReplyDB.PRAddonEnabled,
					label = "Enable/Disable Addon",
					fullWidth = false,
					disabled = false,
					tooltip = "Enable/Disable the addon",
					callback = function(_,_,value) if value == true then TradeSkillMaster_PriceReplyDB.PRAddonEnabled = true elseif value == false then TradeSkillMaster_PriceReplyDB.PRAddonEnabled = false else print("This should not run") end  end,
					},
					{
					type = "EditBox",
					value = TradeSkillMaster_PriceReplyDB.PRLockOutTime,
					label = "Lockout Time",
					fullwidth = false,
					disabled = false,
					tooltip = "Lockout time in seconds before another command can be processed",
					callback = function(_,_,value) PRLockOutTime = value;TradeSkillMaster_PriceReplyDB.PRLockOutTime = PRLockOutTime; end,
					},
					{
					type = "Button",
					text = "Reset all Price Reply settings",
					fullwidth = true,
					disabled = false,
					tooltip = "Reset all of price reply settings to default values",
					callback = function()
						TradeSkillMaster_PriceReplyDB.PRAddonEnabled = "Enabled";
						TradeSkillMaster_PriceReplyDB.PRTrigger = "PR: ";
						TradeSkillMaster_PriceReplyDB.PRLockOutTime = 15
						TradeSkillMaster_PriceReplyDB.PRChannel = "WHISPER"
						end,
					},
				},
			},
			{
				type = "InlineGroup",
				layout = "flow",
				fullWidth = true,
				title = "Reply Options for channels",
				children = {
					{
					type = "Dropdown",
					multiselect = false,
					list = ReplyChannelSayDropDownBox,
					value = TradeSkillMaster_PriceReplyDB.PRChannel,
					label = "Select channel to reply to for say:",
					fullWidth = false,
					disabled = false,
					tooltip = "Select a reply method",
					callback = function(_,_,key) PRChannel = tostring(key); TradeSkillMaster_PriceReplyDB.PRChannel = PRChannel; end,
					},
					{
					type = "Dropdown",
					multiselect = false,
					list = ReplyChannelGuildDropDownBox,
					value = TradeSkillMaster_PriceReplyDB.PRGuildChannel,
					label = "Select channel to reply to for guild:",
					fullWidth = false,
					disabled = false,
					tooltip = "Select a reply method",
					callback = function(_,_,key) PRGuildChannel = tostring(key); TradeSkillMaster_PriceReplyDB.PRGuildChannel = PRGuildChannel; end,
					},
				},
			},
		},
	}
}
	TSMAPI:BuildPage(parent, page)
end

--- End TSM STuff


----------Whisper Event----------------
function TSMPREvents.CHAT_MSG_WHISPER(MSG,Auth)
	PRAddonEnabled = TradeSkillMaster_PriceReplyDB.PRAddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,PRTriggerLength)
	local MSG = MSG
	local Auth = Auth
	--- Price Get --
	local PRPriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PRPriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:GetData("lastCompleteScanTime")
	local PRTimeLastScannedHours = floor(TSMPriceReply:PR_ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local PRTimeLastScannedMinutes = floor(TSMPriceReply:PR_ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = TSMPriceReply:PR_LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,PRTrigger) and PRPriceMarket ~= nil and PRPriceMin ~= nil and PRAddonEnabled == true and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Gold")
		local MktSILVER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Silver")
		local MktCOPPER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Gold")
		local MinSILVER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Silver")
		local MinCOPPER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Copper")

		--- Message to send and channel--
		local PRTHEMESSAGE = ("Price Reply: Market Price: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."Current Min buyout: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Last scanned: "..PRTimeLastScannedHours.." Hrs "..PRTimeLastScannedMinutes.." Mins Ago")
		print(PRTHEMESSAGE)
		SendChatMessage(PRTHEMESSAGE, "WHISPER", "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	end
end


----- Guild event ----
function TSMPREvents.CHAT_MSG_GUILD(MSG,Auth)
	PRAddonEnabled = TradeSkillMaster_PriceReplyDB.PRAddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,PRTriggerLength)
	local MSG = MSG
	local Auth = Auth
	local PRGuildChannel = TradeSkillMaster_PriceReplyDB.PRGuildChannel --- Only used for guild channel
	--- Price Get --
	local PRPriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PRPriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:GetData("lastCompleteScanTime")
	local PRTimeLastScannedHours = floor(TSMPriceReply:PR_ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local PRTimeLastScannedMinutes = floor(TSMPriceReply:PR_ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = TSMPriceReply:PR_LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,PRTrigger) and PRPriceMarket ~= nil and PRPriceMin ~= nil and PRAddonEnabled == true and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Gold")
		local MktSILVER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Silver")
		local MktCOPPER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Gold")
		local MinSILVER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Silver")
		local MinCOPPER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Copper")

		--- Message to send and channel--
		local PRTHEMESSAGE = ("Price Reply: Market Price: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."Current Min buyout: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Last scanned: "..PRTimeLastScannedHours.." Hrs "..PRTimeLastScannedMinutes.." Mins Ago")
		--print(PRTHEMESSAGE)
		SendChatMessage(PRTHEMESSAGE, PRGuildChannel, "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	end
end


---- /say ---
function TSMPREvents.CHAT_MSG_SAY(MSG,Auth)
	PRAddonEnabled = TradeSkillMaster_PriceReplyDB.PRAddonEnabled --- check it
	local MSGTRIG = string.sub(MSG ,0 ,PRTriggerLength)
	local MSG = MSG
	local Auth = Auth
	--- Price Get --
	local PRPriceMarket = TSMAPI:GetItemValue(MSG,"DBMarket")
	local PRPriceMin = TSMAPI:GetItemValue(MSG,"DBMinBuyout")
	-- time functions ---
	local Current = time()
	local Past = TSMAPI:GetData("lastCompleteScanTime")
	local PRTimeLastScannedHours = floor(TSMPriceReply:PR_ConvertTime(Current, Past) / 3600)-- 1 min is 60 seconds and 60 minutes in 1 hour so 60 * 60 = 3600
	local PRTimeLastScannedMinutes = floor(TSMPriceReply:PR_ConvertTime(Current, Past) / 60) -- convert minues
	local LastRunCheck = TSMPriceReply:PR_LastRunCheck()
	-----------------------------------------------------------------

	if string.find(MSG,PRTrigger) and PRPriceMarket ~= nil and PRPriceMin ~= nil and PRAddonEnabled == true and LastRunCheck == "Yes" then
		-- Market Prices --
		local MktGOLD = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Gold")
		local MktSILVER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Silver")
		local MktCOPPER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMarket,"Copper")

		--- Minimum Price --
		local MinGOLD = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Gold")
		local MinSILVER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Silver")
		local MinCOPPER = TSMPriceReply:PR_ConvertPriceToMoney(PRPriceMin,"Copper")

		--- Message to send and channel--
		local PRTHEMESSAGE = ("Price Reply: Market Price: "..MktGOLD.."g"..MktSILVER.."s"..MktCOPPER.."c".." / ".."Current Min buyout: "..MinGOLD.."g"..MinSILVER.."s"..MinCOPPER.."c".." / ".."Last scanned: "..PRTimeLastScannedHours.." Hrs "..PRTimeLastScannedMinutes.." Mins Ago")
		--print(PRTHEMESSAGE)
		SendChatMessage(PRTHEMESSAGE, PRChannel, "Common", Auth)

		---
		LastRunDelayTime = time() --- gets the current time
		----
	end

end

-------------------------- Useful Functions --------------
function TSMPriceReply:PR_ConvertPriceToMoney(PRICE,TYPE)
	local GOLD
	local SILVER
	local COPPER
	if PRICE == nil then Price = 0 end -- make sure it is a number
	if TYPE == "Gold" then
		GOLD = floor(PRICE/10000) -- divide price by 10000 to decide gold and floor it to get rid of hang overs
		return GOLD or 0 -- Make sure it always returns a number
	elseif TYPE == "Silver" then
		SILVER = floor(strsub(PRICE, -4) / 100) -- strsub will only see the last 4 numbers of a sentece and divide it by 100
		return SILVER or 0
	elseif TYPE == "Copper" then
		COPPER = floor(strsub(PRICE, -2)) -- no division needed for 10th's
		return COPPER or 0
	end
end
------
function TSMPriceReply:PR_ConvertTime(Current, Past)
	local Current = Current
	local Past = Past
	local Difference = (Current - Past)
	return Difference
end
----------
function TSMPriceReply:PR_LastRunCheck()
	local Current = time()
	local Past = (LastRunDelayTime + PRLockOutTime)
	if Current > Past then
		return "Yes"
	else
		return "No"
	end
end
-----------
